#pragma once

#include "ActorInterface.h"
#include "WASCommand.h"
#include "WASActor.h"

class CWASGetUserProfile : public CWASCommand
{
public:
	CWASGetUserProfile(CWASActor *pActor);
	~CWASGetUserProfile(void);

	void ExecuteAsync(void);

	void SetParameter(LPCWSTR strUserID)
	{
		m_strUserID = strUserID;
		m_sUserInfo.strUserID = m_strUserID;
	}

private:
	bool ParseAndEventFire(nfc::CIkXMLDom * pDom);

protected:
	// override in drived class
	virtual void OnWasResponse(trid_t /*trid*/, bool /*bSuccess*/, int /*nWinINetErrorCode*/, int /*nHttpResponseCode*/, 
		LPCSTR /*szWasResCodeInHeader*/, 
		LPCSTR /*szWasResCodeInXml*/,
		nfc::CIkXMLDom * /*pDom*/);

	virtual void OnRequestTimeout(CHttpFacade * /*pHttpF*/, DWORD /*dwSeconds*/);

private:


	WSTRING m_strUserID;
	P_GT_USER_PROFILE_DATA m_sUserInfo;
};
